searchNodes=[{"doc":"EdgeDB client for Elixir. EdgeDB module provides an API to run a connection pool, query EdgeDB, perform transactions and their rollback. A simple example of how to use it: iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query! ( client , &quot; ...(2)&gt; select Person{ ...(2)&gt; first_name, ...(2)&gt; middle_name, ...(2)&gt; last_name ...(2)&gt; } filter .last_name = &lt;str&gt;$last_name; ...(2)&gt; &quot; , last_name : &quot;Radcliffe&quot; ) # EdgeDB.Set &lt; { # EdgeDB.Object &lt; first_name := &quot;Daniel&quot; , middle_name := &quot;Jacob&quot; , last_name := &quot;Radcliffe&quot; &gt; } &gt;","ref":"EdgeDB.html","title":"EdgeDB","type":"module"},{"doc":"Mark the client as read-only. This function will mark the client as read-only, so any modifying queries will return errors.","ref":"EdgeDB.html#as_readonly/1","title":"EdgeDB.as_readonly/1","type":"function"},{"doc":"Creates a child specification for the supervisor to start the EdgeDB pool. See start_option/0 for supported connection options.","ref":"EdgeDB.html#child_spec/1","title":"EdgeDB.child_spec/1","type":"function"},{"doc":"Execute an EdgeQL command or commands on the client without returning anything. See query_option/0 for supported options.","ref":"EdgeDB.html#execute/4","title":"EdgeDB.execute/4","type":"function"},{"doc":"Execute an EdgeQL command or commands on the client without returning anything. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. See query_option/0 for supported options.","ref":"EdgeDB.html#execute!/4","title":"EdgeDB.execute!/4","type":"function"},{"doc":"Execute the query on the client and return the results as a {:ok, set} tuple if successful, where set is EdgeDB.Set . iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , % EdgeDB.Set { } = set } = EdgeDB . query ( client , &quot;select 42&quot; ) iex(3)&gt; set # EdgeDB.Set &lt; { 42 } &gt; If an error occurs, it will be returned as a {:error, exception} tuple where exception is EdgeDB.Error . iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :error , % EdgeDB.Error { } = error } = EdgeDB . query ( client , &quot;select UndefinedType&quot; ) iex(2)&gt; raise error ** (EdgeDB.Error) InvalidReferenceError: object type or alias &#39;default::UndefinedType&#39; does not exist If a query has arguments, they can be passed as a list for a query with positional arguments or as a list of keywords for a query with named arguments. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , % EdgeDB.Set { } = set } = EdgeDB . query ( client , &quot;select &lt;int64&gt;$0&quot; , [ 42 ] ) iex(3)&gt; set # EdgeDB.Set &lt; { 42 } &gt; iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , % EdgeDB.Set { } = set } = EdgeDB . query ( client , &quot;select &lt;int64&gt;$arg&quot; , arg : 42 ) iex(3)&gt; set # EdgeDB.Set &lt; { 42 } &gt; Automatic retries of read-only queries If the client is able to recognize the query as a read-only query (i.e. the query does not change the data in the database using delete , insert or other statements), then the client will try to repeat the query automatically (as long as the query is not executed in a transaction, because then retrying transactions are used). See query_option/0 for supported options.","ref":"EdgeDB.html#query/4","title":"EdgeDB.query/4","type":"function"},{"doc":"Execute the query on the client and return the results as EdgeDB.Set . If an error occurs while executing the query, it will be raised as as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query!/4","title":"EdgeDB.query!/4","type":"function"},{"doc":"Execute the query on the client and return the results as a {:ok, json} tuple if successful, where json is JSON encoded string. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_json/4","title":"EdgeDB.query_json/4","type":"function"},{"doc":"Execute the query on the client and return the results as JSON encoded string. If an error occurs while executing the query, it will be raised as as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_json!/4","title":"EdgeDB.query_json!/4","type":"function"},{"doc":"Execute the query on the client and return a singleton-returning result as a {:ok, result} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single/4","title":"EdgeDB.query_required_single/4","type":"function"},{"doc":"Execute the query on the client and return a singleton-returning result. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single!/4","title":"EdgeDB.query_required_single!/4","type":"function"},{"doc":"Execute the query on the client and return a singleton-returning result as a {:ok, json} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single_json/4","title":"EdgeDB.query_required_single_json/4","type":"function"},{"doc":"Execute the query on the client and return a singleton-returning result as JSON string. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_required_single_json!/4","title":"EdgeDB.query_required_single_json!/4","type":"function"},{"doc":"Execute the query on the client and return an optional singleton-returning result as a {:ok, result} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single/4","title":"EdgeDB.query_single/4","type":"function"},{"doc":"Execute the query on the client and return an optional singleton-returning result. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single!/4","title":"EdgeDB.query_single!/4","type":"function"},{"doc":"Execute the query on the client and return an optional singleton-returning result as a {:ok, json} tuple. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single_json/4","title":"EdgeDB.query_single_json/4","type":"function"},{"doc":"Execute the query on the client and return an optional singleton-returning result as JSON encoded string. If an error occurs while executing the query, it will be raised as an EdgeDB.Error exception. For the general usage, see EdgeDB.query/4 . See query_option/0 for supported options.","ref":"EdgeDB.html#query_single_json!/4","title":"EdgeDB.query_single_json!/4","type":"function"},{"doc":"Rollback an open transaction. See rollback_option/0 for supported options. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :error , :tx_rollback } = ...(2)&gt; EdgeDB . transaction ( client , fn tx_conn -&gt; ...(2)&gt; EdgeDB . rollback ( tx_conn , reason : :tx_rollback ) ...(2)&gt; end )","ref":"EdgeDB.html#rollback/2","title":"EdgeDB.rollback/2","type":"function"},{"doc":"Creates a pool of EdgeDB connections linked to the current process. If the first argument is a string, it will be assumed to be the DSN and passed as [dsn: dsn] keyword list to connect. iex(1)&gt; { :ok , _client } = EdgeDB . start_link ( &quot;edgedb://edgedb:edgedb@localhost:5656/edgedb&quot; ) Otherwise, if the first argument is a list, it will be used as is to connect. See start_option/0 for supported connection options. iex(1)&gt; { :ok , _client } = EdgeDB . start_link ( instance : &quot;edgedb_elixir&quot; )","ref":"EdgeDB.html#start_link/1","title":"EdgeDB.start_link/1","type":"function"},{"doc":"Creates a pool of EdgeDB connections linked to the current process. The first argument is the string which will be assumed as the DSN and passed as [dsn: dsn] keyword list along with other options to connect. See start_option/0 for supported connection options. iex(1)&gt; { :ok , _client } = EdgeDB . start_link ( &quot;edgedb://edgedb:edgedb@localhost:5656/edgedb&quot; , tls_security : :insecure )","ref":"EdgeDB.html#start_link/2","title":"EdgeDB.start_link/2","type":"function"},{"doc":"Open a retryable transaction loop. EdgeDB clients support transactions that are robust to network errors, server failure, and some transaction conflicts. For more information see RFC . The result of the transaction is the {:ok, result} tuple, where result is the result of the callback function executed in the transaction. To rollback an open transaction, use EdgeDB.rollback/2 . EdgeDB.transaction/3 calls cannot be nested more than once. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , tickets } = EdgeDB . transaction ( client , fn client -&gt; ...(2)&gt; EdgeDB . query! ( client , &quot;insert Ticket{ number := 2}&quot; ) ...(2)&gt; EdgeDB . query! ( client , &quot;select Ticket&quot; ) ...(2)&gt; end ) iex(3)&gt; tickets # EdgeDB.Set &lt; { # EdgeDB.Object &lt; &gt; } &gt; See transaction_option/0 for supported options.","ref":"EdgeDB.html#transaction/3","title":"EdgeDB.transaction/3","type":"function"},{"doc":"Returns client with adjusted state. See EdgeDB.with_default_module/2 , EdgeDB.with_module_aliases/2 / EdgeDB.without_module_aliases/2 , EdgeDB.with_config/2 / EdgeDB.without_config/2 , EdgeDB.with_globals/2 / EdgeDB.without_globals/2 for more information.","ref":"EdgeDB.html#with_client_state/2","title":"EdgeDB.with_client_state/2","type":"function"},{"doc":"Returns client with adjusted session config. This is equivalent to using the configure session set command.","ref":"EdgeDB.html#with_config/2","title":"EdgeDB.with_config/2","type":"function"},{"doc":"Returns client with adjusted default module. This is equivalent to using the set module command, or using the reset module command when giving nil .","ref":"EdgeDB.html#with_default_module/2","title":"EdgeDB.with_default_module/2","type":"function"},{"doc":"Returns client with adjusted global values. This is equivalent to using the set global command.","ref":"EdgeDB.html#with_globals/2","title":"EdgeDB.with_globals/2","type":"function"},{"doc":"Returns client with adjusted module aliases. This is equivalent to using the set alias command.","ref":"EdgeDB.html#with_module_aliases/2","title":"EdgeDB.with_module_aliases/2","type":"function"},{"doc":"Configure the client so that futher transactions retries are executed with custom retries options. See t:retry_option/0 for supported options.","ref":"EdgeDB.html#with_retry_options/2","title":"EdgeDB.with_retry_options/2","type":"function"},{"doc":"Configure the client so that futher transactions are executed with custom transaction options. See t:edgedb_transaction_option/0 for supported options.","ref":"EdgeDB.html#with_transaction_options/2","title":"EdgeDB.with_transaction_options/2","type":"function"},{"doc":"Returns client without specified session config. This is equivalent to using the configure session reset command.","ref":"EdgeDB.html#without_config/2","title":"EdgeDB.without_config/2","type":"function"},{"doc":"Returns client without specified globals. This is equivalent to using the reset global command.","ref":"EdgeDB.html#without_globals/2","title":"EdgeDB.without_globals/2","type":"function"},{"doc":"Returns client without specified module aliases. This is equivalent to using the reset alias command.","ref":"EdgeDB.html#without_module_aliases/2","title":"EdgeDB.without_module_aliases/2","type":"function"},{"doc":"Connection pool process name, pid or the separate structure that allows adjusted configuration for queries executed on the connection. See EdgeDB.as_readonly/1 , EdgeDB.with_retry_options/2 , EdgeDB.with_transaction_options/2 for more information.","ref":"EdgeDB.html#t:client/0","title":"EdgeDB.client/0","type":"type"},{"doc":"Parameters for connecting to an EdgeDB instance and configuring the connection itself. EdgeDB clients allow a very flexible way to define how to connect to an instance. For more information, see the official EdgeDB documentation on connection parameters . Supported options: :dsn - DSN that defines the primary information that can be used to connect to the instance. :credentials - a JSON string containing the instance parameters to connect. :credentials_file - the path to the instance credentials file containing the instance parameters to connect to. :host - the host name of the instance to connect to. :port - the port number of the instance to connect to. :database - the name of the database to connect to. :user - the user name to connect to. :password - the user password to connect. :secret_key - the secret key to be used for authentication. :tls_ca - TLS certificate to be used when connecting to the instance. :tls_ca_path - the path to the TLS certificate to be used when connecting to the instance. :tls_security - security mode for the TLS connection. See tls_security/0 . :timeout - timeout for TCP operations with the database, such as connecting to it, sending or receiving data. :command_timeout - not in use right now and added for compatibility with the official clients . :server_settings - not in use right now and added for compatibility with the official clients . :tcp - options for the TCP connection. :ssl - options for TLS connection. :transaction - options for EdgeDB transactions, which correspond to the EdgeQL transaction statement . See EdgeDB.Client.transaction_option/0 . :retry - options to retry transactions in case of errors. See t:retry_option/0 . :codecs - list of custom codecs for EdgeDB scalars. :connection - module that implements the DBConnection behavior for EdgeDB. For tests, it's possible to use EdgeDB.Sandbox to support automatic rollback after tests are done. :max_concurrency - maximum number of pool connections, despite what EdgeDB recommends. :client_state - an EdgeDB.Client.State struct that will be used in queries by default.","ref":"EdgeDB.html#t:connect_option/0","title":"EdgeDB.connect_option/0","type":"type"},{"doc":"Options for EdgeDB.query*/4 functions. These options can be used with the following functions: EdgeDB.query/4 EdgeDB.query!/4 EdgeDB.query_single/4 EdgeDB.query_single!/4 EdgeDB.query_required_single/4 EdgeDB.query_required_single!/4 EdgeDB.query_json/4 EdgeDB.query_json!/4 EdgeDB.query_single_json/4 EdgeDB.query_single_json!/4 EdgeDB.query_required_single_json/4 EdgeDB.query_required_single_json!/4 Supported options: :cardinality - expected number of items in set. :output_format - preferred format of query result. :retry - options for read-only queries retries. other - check DBConnection.start_option/0 .","ref":"EdgeDB.html#t:query_option/0","title":"EdgeDB.query_option/0","type":"type"},{"doc":"The result that will be returned if the EdgeDB.query*/4 function succeeds.","ref":"EdgeDB.html#t:result/0","title":"EdgeDB.result/0","type":"type"},{"doc":"Options for EdgeDB.rollback/2 . Supported options: :reason - the reason for the rollback. Will be returned from EdgeDB.transaction/3 as a {:error, reason} tuple in case block execution is interrupted.","ref":"EdgeDB.html#t:rollback_option/0","title":"EdgeDB.rollback_option/0","type":"type"},{"doc":"Options for EdgeDB.start_link/1 . See connect_option/0 and DBConnection.start_option/0 .","ref":"EdgeDB.html#t:start_option/0","title":"EdgeDB.start_option/0","type":"type"},{"doc":"Security modes for TLS connection to EdgeDB server. For more information, see the official EdgeDB documentation on connection parameters . Supported options: :insecure - trust a self-signed or user-signed TLS certificate, which is useful for local development. :no_host_verification - verify the TLS certificate, but not the host name. :strict - verify both the TLS certificate and the hostname. :default - the same as :strict .","ref":"EdgeDB.html#t:tls_security/0","title":"EdgeDB.tls_security/0","type":"type"},{"doc":"Options for EdgeDB.transaction/3 . See t:edgedb_transaction_option/0 and DBConnection.start_option/0 .","ref":"EdgeDB.html#t:transaction_option/0","title":"EdgeDB.transaction_option/0","type":"type"},{"doc":"Сlient is a structure that stores a custom configuration to execute EdgeQL queries and has a reference to a connection or pool of connections. After starting the pool via EdgeDB.start_link/1 or siblings, the client instance for the pool will be implicitly registered. In case you want to change the behavior of your queries, you will use the EdgeDB.Client , which is acceptable by all EdgeDB API and will be provided to you in a callback in the EdgeDB.transaction/3 function.","ref":"EdgeDB.Client.html","title":"EdgeDB.Client","type":"module"},{"doc":"Options for transactions and read-only queries retries. See EdgeDB.transaction/3 . Supported options: :transaction_conflict - the rule that will be used in case of any transaction conflict. :network_error - rule which will be used when any network error occurs on the client.","ref":"EdgeDB.Client.html#t:retry_option/0","title":"EdgeDB.Client.retry_option/0","type":"type"},{"doc":"Options for a retry rule for transactions retries. See EdgeDB.transaction/3 . Supported options: :attempts - the number of attempts to retry the transaction in case of an error. :backoff - function to determine the backoff before the next attempt to run a transaction.","ref":"EdgeDB.Client.html#t:retry_rule/0","title":"EdgeDB.Client.retry_rule/0","type":"type"},{"doc":"Client is structure with stored configuration for executing EdgeQL queries and reference to pool or connection. Fields: :conn - reference to connection or pool of connections. :readonly - flag specifying that the client is read-only. :transaction_options - options for EdgeDB transactions. :retry_options - options for a retry rule for transactions retries. :state - execution context that affects the execution of EdgeQL commands.","ref":"EdgeDB.Client.html#t:t/0","title":"EdgeDB.Client.t/0","type":"type"},{"doc":"Options for EdgeDB transactions. These options are responsible for building the appropriate EdgeQL statement to start transactions and they correspond to the EdgeQL transaction statement . Supported options: :isolation - If :serializable is used, the built statement will use the isolation serializable mode. Currently only :serializable is supported by this client and EdgeDB. :readonly - if set to true then the built statement will use read only mode, otherwise read write will be used. The default is false . :deferrable - if set to true then the built statement will use deferrable mode, otherwise not deferrable will be used. The default is false .","ref":"EdgeDB.Client.html#t:transaction_option/0","title":"EdgeDB.Client.transaction_option/0","type":"type"},{"doc":"State for the client is an execution context that affects the execution of EdgeQL commands in different ways: default module. module aliases. session config. global values. The most convenient way to work with the state is to use the EdgeDB API to change a required part of the state. See EdgeDB.with_client_state/2 , EdgeDB.with_default_module/2 , EdgeDB.with_module_aliases/2 / EdgeDB.without_module_aliases/2 , EdgeDB.with_config/2 / EdgeDB.without_config/2 and EdgeDB.with_globals/2 / EdgeDB.without_globals/2 for more information.","ref":"EdgeDB.Client.State.html","title":"EdgeDB.Client.State","type":"module"},{"doc":"Returns an EdgeDB.Client.State with adjusted session config. This is equivalent to using the configure session set command.","ref":"EdgeDB.Client.State.html#with_config/2","title":"EdgeDB.Client.State.with_config/2","type":"function"},{"doc":"Returns an EdgeDB.Client.State with adjusted default module. This is equivalent to using the set module command, or using the reset module command when giving nil .","ref":"EdgeDB.Client.State.html#with_default_module/2","title":"EdgeDB.Client.State.with_default_module/2","type":"function"},{"doc":"Returns an EdgeDB.Client.State with adjusted global values. This is equivalent to using the set global command.","ref":"EdgeDB.Client.State.html#with_globals/2","title":"EdgeDB.Client.State.with_globals/2","type":"function"},{"doc":"Returns an EdgeDB.Client.State with adjusted module aliases. This is equivalent to using the set alias command.","ref":"EdgeDB.Client.State.html#with_module_aliases/2","title":"EdgeDB.Client.State.with_module_aliases/2","type":"function"},{"doc":"Returns an EdgeDB.Client.State without specified session config. This is equivalent to using the configure session reset command.","ref":"EdgeDB.Client.State.html#without_config/2","title":"EdgeDB.Client.State.without_config/2","type":"function"},{"doc":"Returns an EdgeDB.Client.State without specified globals. This is equivalent to using the reset global command.","ref":"EdgeDB.Client.State.html#without_globals/2","title":"EdgeDB.Client.State.without_globals/2","type":"function"},{"doc":"Returns an EdgeDB.Client.State without specified module aliases. This is equivalent to using the reset alias command.","ref":"EdgeDB.Client.State.html#without_module_aliases/2","title":"EdgeDB.Client.State.without_module_aliases/2","type":"function"},{"doc":"State for the client is an execution context that affects the execution of EdgeQL commands.","ref":"EdgeDB.Client.State.html#t:t/0","title":"EdgeDB.Client.State.t/0","type":"opaque"},{"doc":"Custom connection for tests that involve modifying the database through the driver. This connection, when started, wraps the actual connection to EdgeDB into a transaction using the start transaction statement. And then further calls to EdgeDB.transaction/3 will result in executing declare savepoint statement instead of start transaction . To use this module in tests, change the configuration of the :edgedb application in the config/tests.exs : config :edgedb , connection : EdgeDB.Sandbox Then modify the test case to initialize the sandbox when you run the test and to clean the sandbox at the end of the test: defmodule MyApp.TestCase do use ExUnit.CaseTemplate # other stuff for this case (e.g. Phoenix setup, Plug configuration, etc.) setup _context do EdgeDB.Sandbox . initialize ( MyApp.EdgeDB ) on_exit ( fn -&gt; EdgeDB.Sandbox . clean ( MyApp.EdgeDB ) end ) :ok end end","ref":"EdgeDB.Sandbox.html","title":"EdgeDB.Sandbox","type":"module"},{"doc":"Release the connection transaction.","ref":"EdgeDB.Sandbox.html#clean/1","title":"EdgeDB.Sandbox.clean/1","type":"function"},{"doc":"Wrap a connection in a transaction.","ref":"EdgeDB.Sandbox.html#initialize/1","title":"EdgeDB.Sandbox.initialize/1","type":"function"},{"doc":"An immutable value represeting an EdgeDB cfg::memory value as a quantity of memory storage. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; mem = EdgeDB . query_required_single! ( client , &quot;select &lt;cfg::memory&gt;&#39;5KiB&#39;&quot; ) # EdgeDB.ConfigMemory &lt; &quot;5KiB&quot; &gt; iex(3)&gt; EdgeDB.ConfigMemory . bytes ( mem ) 5120","ref":"EdgeDB.ConfigMemory.html","title":"EdgeDB.ConfigMemory","type":"module"},{"doc":"Get a quantity of memory storage in bytes.","ref":"EdgeDB.ConfigMemory.html#bytes/1","title":"EdgeDB.ConfigMemory.bytes/1","type":"function"},{"doc":"An immutable value represeting an EdgeDB cfg::memory value as a quantity of memory storage.","ref":"EdgeDB.ConfigMemory.html#t:t/0","title":"EdgeDB.ConfigMemory.t/0","type":"opaque"},{"doc":"An immutable value represeting an EdgeDB cal::date_duration value. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query_required_single! ( client , &quot;select &lt;cal::date_duration&gt;&#39;1 year 2 days&#39;&quot; ) # EdgeDB.Duration &lt; &quot;P1Y20D&quot; &gt;","ref":"EdgeDB.DateDuration.html","title":"EdgeDB.DateDuration","type":"module"},{"doc":"An immutable value represeting an EdgeDB cal::date_duration value. Fields: :days - number of days. :months - number of months.","ref":"EdgeDB.DateDuration.html#t:t/0","title":"EdgeDB.DateDuration.t/0","type":"type"},{"doc":"An immutable value representing an EdgeDB named tuple value. EdgeDB.NamedTuple implements Access behavior to access fields by index or key and Enumerable protocol for iterating over tuple values. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; nt = EdgeDB . query_required_single! ( client , &quot;select (a := 1, b := &#39;a&#39;, c := [3])&quot; ) # EdgeDB.NamedTuple &lt; a : 1 , b : &quot;a&quot; , c : [ 3 ] &gt; iex(3)&gt; nt [ :b ] &quot;a&quot; iex(4)&gt; nt [ &quot;c&quot; ] [ 3 ] iex(4)&gt; nt [ 0 ] 1","ref":"EdgeDB.NamedTuple.html","title":"EdgeDB.NamedTuple","type":"module"},{"doc":"Get named tuple keys. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; nt = EdgeDB . query_required_single! ( client , &quot;select (a := 1, b := &#39;a&#39;, c := [3])&quot; ) iex(3)&gt; EdgeDB.NamedTuple . keys ( nt ) [ &quot;a&quot; , &quot;b&quot; , &quot;c&quot; ]","ref":"EdgeDB.NamedTuple.html#keys/1","title":"EdgeDB.NamedTuple.keys/1","type":"function"},{"doc":"Convert a named tuple into a regular map. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; nt = EdgeDB . query_required_single! ( client , &quot;select (a := 1, b := &#39;a&#39;, c := [3])&quot; ) iex(3)&gt; EdgeDB.NamedTuple . to_map ( nt ) %{ &quot;a&quot; =&gt; 1 , &quot;b&quot; =&gt; &quot;a&quot; , &quot;c&quot; =&gt; [ 3 ] }","ref":"EdgeDB.NamedTuple.html#to_map/1","title":"EdgeDB.NamedTuple.to_map/1","type":"function"},{"doc":"Convert a named tuple to a regular erlang tuple. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; nt = EdgeDB . query_required_single! ( client , &quot;select (a := 1, b := &#39;a&#39;, c := [3])&quot; ) iex(3)&gt; EdgeDB.NamedTuple . to_tuple ( nt ) { 1 , &quot;a&quot; , [ 3 ] }","ref":"EdgeDB.NamedTuple.html#to_tuple/1","title":"EdgeDB.NamedTuple.to_tuple/1","type":"function"},{"doc":"An immutable value representing an EdgeDB named tuple value.","ref":"EdgeDB.NamedTuple.html#t:t/0","title":"EdgeDB.NamedTuple.t/0","type":"opaque"},{"doc":"An immutable representation of an object instance returned from a query. EdgeDB.Object implements Access behavior to access properties by key. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Object { } = object = iex(2)&gt; EdgeDB . query_required_single! ( client , &quot; ...(2)&gt; select schema::ObjectType{ ...(2)&gt; name ...(2)&gt; } ...(2)&gt; filter .name = &#39;std::Object&#39; ...(2)&gt; limit 1 ...(2)&gt; &quot; ) # EdgeDB.Object &lt; name := &quot;std::Object&quot; &gt; iex(3)&gt; object [ :name ] &quot;std::Object&quot; iex(4)&gt; object [ &quot;name&quot; ] &quot;std::Object&quot; Links and links properties In EdgeDB, objects can have links to other objects or a set of objects. You can use the same syntax to access links values as for object properties. Links can also have their own properties (denoted as @&lt;link_prop_name&gt; in EdgeQL syntax). You can use the same property name as in the query to access them from the links. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Object { } = object = iex(2)&gt; EdgeDB . query_required_single! ( client , &quot; ...(2)&gt; select schema::Property { ...(2)&gt; name, ...(2)&gt; annotations: { ...(2)&gt; name, ...(2)&gt; @value ...(2)&gt; } ...(2)&gt; } ...(2)&gt; filter .name = &#39;listen_port&#39; and .source.name = &#39;cfg::Config&#39; ...(2)&gt; limit 1 ...(2)&gt; &quot; ) # EdgeDB.Object &lt; name := &quot;listen_port&quot; , annotations := # EdgeDB.Set &lt; { # EdgeDB.Object &lt; name := &quot;cfg::system&quot; , @value := &quot;true&quot; &gt; } &gt; &gt; iex(3)&gt; annotations = object [ :annotations ] # EdgeDB.Set &lt; { # EdgeDB.Object &lt; name := &quot;cfg::system&quot; , @value := &quot;true&quot; &gt; } &gt; iex(4)&gt; link = Enum . at ( annotations , 0 ) # EdgeDB.Object &lt; name := &quot;cfg::system&quot; , @value := &quot;true&quot; &gt; iex(5)&gt; link [ &quot;@value&quot; ] &quot;true&quot;","ref":"EdgeDB.Object.html","title":"EdgeDB.Object","type":"module"},{"doc":"Get object fields names (properties, links and link propries) as list of strings. See fields_option/0 for supported options.","ref":"EdgeDB.Object.html#fields/2","title":"EdgeDB.Object.fields/2","type":"function"},{"doc":"Get object link propeties names as list.","ref":"EdgeDB.Object.html#link_properties/1","title":"EdgeDB.Object.link_properties/1","type":"function"},{"doc":"Get object links names as list.","ref":"EdgeDB.Object.html#links/1","title":"EdgeDB.Object.links/1","type":"function"},{"doc":"Get object properties names as list. See properties_option/0 for supported options.","ref":"EdgeDB.Object.html#properties/2","title":"EdgeDB.Object.properties/2","type":"function"},{"doc":"Convert an object into a regular map. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; object = iex(2)&gt; EdgeDB . query_required_single! ( client , &quot; ...(2)&gt; select schema::Property { ...(2)&gt; name, ...(2)&gt; annotations: { ...(2)&gt; name, ...(2)&gt; @value ...(2)&gt; } ...(2)&gt; } ...(2)&gt; filter .name = &#39;listen_port&#39; and .source.name = &#39;cfg::Config&#39; ...(2)&gt; limit 1 ...(2)&gt; &quot; ) iex(3)&gt; EdgeDB.Object . to_map ( object ) %{ &quot;name&quot; =&gt; &quot;listen_port&quot; , &quot;annotations&quot; =&gt; [ %{ &quot;name&quot; =&gt; &quot;cfg::system&quot; , &quot;@value&quot; =&gt; &quot;true&quot; } ] }","ref":"EdgeDB.Object.html#to_map/1","title":"EdgeDB.Object.to_map/1","type":"function"},{"doc":"Options for EdgeDB.Object.fields/2 Supported options: :properties - flag to include object properties in returning list. The default is true . :links - flag to include object links in returning list. The default is true . :link_properies - flag to include object link properties in returning list. The default is true . :id - flag to include implicit :id in returning list. The default is false . :implicit - flag to include implicit fields (like :id or :__tid__ ) in returning list. The default is false .","ref":"EdgeDB.Object.html#t:fields_option/0","title":"EdgeDB.Object.fields_option/0","type":"type"},{"doc":"An immutable representation of an object instance returned from a query.","ref":"EdgeDB.Object.html#t:object/0","title":"EdgeDB.Object.object/0","type":"opaque"},{"doc":"Options for EdgeDB.Object.properties/2 Supported options: :id - flag to include implicit :id in returning list. The default is false . :implicit - flag to include implicit properties (like :id or :__tid__ ) in returning list. The default is false .","ref":"EdgeDB.Object.html#t:properties_option/0","title":"EdgeDB.Object.properties_option/0","type":"type"},{"doc":"An immutable representation of an object instance returned from a query. Fields: :id - a unique ID of the object instance in the database.","ref":"EdgeDB.Object.html#t:t/0","title":"EdgeDB.Object.t/0","type":"type"},{"doc":"UUID value.","ref":"EdgeDB.Object.html#t:uuid/0","title":"EdgeDB.Object.uuid/0","type":"type"},{"doc":"A value representing some interval of values. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query_required_single! ( client , &quot;select range(1, 10)&quot; ) # EdgeDB.Range &lt; [ 1 , 10 ) &gt;","ref":"EdgeDB.Range.html","title":"EdgeDB.Range","type":"module"},{"doc":"Create an empty range. iex(1)&gt; EdgeDB.Range . empty ( ) # EdgeDB.Range &lt; empty &gt;","ref":"EdgeDB.Range.html#empty/0","title":"EdgeDB.Range.empty/0","type":"function"},{"doc":"Create new range. iex(1)&gt; EdgeDB.Range . new ( 1.1 , 3.3 , inc_upper : true ) # EdgeDB.Range &lt; [ 1.1 , 3.3 ] &gt;","ref":"EdgeDB.Range.html#new/3","title":"EdgeDB.Range.new/3","type":"function"},{"doc":"Options for EdgeDB.Range.new/3 function. Supported options: :inc_lower - flag whether the created range should strictly include the lower boundary. :inc_upper - flag whether the created range should strictly include the upper boundary. :empty - flag to create an empty range.","ref":"EdgeDB.Range.html#t:creation_option/0","title":"EdgeDB.Range.creation_option/0","type":"type"},{"doc":"A value representing some interval of values.","ref":"EdgeDB.Range.html#t:t/0","title":"EdgeDB.Range.t/0","type":"type"},{"doc":"A value representing some interval of values. Fields: :lower - data for the lower range boundary. :upper - data for the upper range boundary. :inc_lower - flag whether the range should strictly include the lower boundary. :inc_upper - flag whether the range should strictly include the upper boundary. :is_empty - flag for an empty range.","ref":"EdgeDB.Range.html#t:t/1","title":"EdgeDB.Range.t/1","type":"type"},{"doc":"An immutable value represeting an EdgeDB cal::relative_duration value. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query_required_single! ( client , &quot;select &lt;cal::relative_duration&gt;&#39;45.6 seconds&#39;&quot; ) # EdgeDB.RelativeDuration &lt; &quot;PT45.6S&quot; &gt;","ref":"EdgeDB.RelativeDuration.html","title":"EdgeDB.RelativeDuration","type":"module"},{"doc":"An immutable value represeting an EdgeDB cal::relative_duration value. Fields: :months - number of months. :days - number of days. :microseconds - number of microseconds.","ref":"EdgeDB.RelativeDuration.html#t:t/0","title":"EdgeDB.RelativeDuration.t/0","type":"type"},{"doc":"A representation of an immutable set of values returned by a query. Nested sets in the result are also returned as EdgeDB.Set objects. EdgeDB.Set implements Enumerable protocol for iterating over set values. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Set { } = iex(2)&gt; EdgeDB . query! ( client , &quot; ...(2)&gt; select schema::ObjectType{ ...(2)&gt; name ...(2)&gt; } ...(2)&gt; filter .name IN {&#39;std::BaseObject&#39;, &#39;std::Object&#39;, &#39;std::FreeObject&#39;} ...(2)&gt; order by .name ...(2)&gt; &quot; ) # EdgeDB.Set &lt; { # EdgeDB.Object &lt; name := &quot;std::BaseObject&quot; &gt; , # EdgeDB.Object &lt; name := &quot;std::FreeObject&quot; &gt; , # EdgeDB.Object &lt; name := &quot;std::Object&quot; &gt; } &gt;","ref":"EdgeDB.Set.html","title":"EdgeDB.Set","type":"module"},{"doc":"Check if set is empty. iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Set { } = set = EdgeDB . query! ( client , &quot;select Ticket&quot; ) iex(3)&gt; EdgeDB.Set . empty? ( set ) true","ref":"EdgeDB.Set.html#empty?/1","title":"EdgeDB.Set.empty?/1","type":"function"},{"doc":"A representation of an immutable set of values returned by a query.","ref":"EdgeDB.Set.html#t:t/0","title":"EdgeDB.Set.t/0","type":"opaque"},{"doc":"A codec knows how to work with the internal binary data from EdgeDB. The binary protocol specification for the codecs can be found on the official EdgeDB site . Useful links for codec developers: EdgeDB datatypes used in data descriptions . EdgeDB data wire formats . Built-in EdgeDB codec implementations . Custom codecs implementations . Guide to developing custom codecs .","ref":"EdgeDB.Protocol.Codec.html","title":"EdgeDB.Protocol.Codec","type":"protocol"},{"doc":"Function that can decode EdgeDB binary format into an entity.","ref":"EdgeDB.Protocol.Codec.html#decode/3","title":"EdgeDB.Protocol.Codec.decode/3","type":"function"},{"doc":"Function that can encode an entity to EdgeDB binary format.","ref":"EdgeDB.Protocol.Codec.html#encode/3","title":"EdgeDB.Protocol.Codec.encode/3","type":"function"},{"doc":"Codec ID.","ref":"EdgeDB.Protocol.Codec.html#t:id/0","title":"EdgeDB.Protocol.Codec.id/0","type":"type"},{"doc":"","ref":"EdgeDB.Protocol.Codec.html#t:t/0","title":"EdgeDB.Protocol.Codec.t/0","type":"type"},{"doc":"A storage for each codec that the connection knows how to decode.","ref":"EdgeDB.Protocol.CodecStorage.html","title":"EdgeDB.Protocol.CodecStorage","type":"module"},{"doc":"Find a codec in the storage by ID.","ref":"EdgeDB.Protocol.CodecStorage.html#get/2","title":"EdgeDB.Protocol.CodecStorage.get/2","type":"function"},{"doc":"Find a codec in the storage by type name.","ref":"EdgeDB.Protocol.CodecStorage.html#get_by_name/2","title":"EdgeDB.Protocol.CodecStorage.get_by_name/2","type":"function"},{"doc":"A storage for each codec that the connection knows how to decode.","ref":"EdgeDB.Protocol.CodecStorage.html#t:t/0","title":"EdgeDB.Protocol.CodecStorage.t/0","type":"type"},{"doc":"Behaviour for custom scalar codecs. See custom codecs development guide for more information.","ref":"EdgeDB.Protocol.CustomCodec.html","title":"EdgeDB.Protocol.CustomCodec","type":"behaviour"},{"doc":"Get name for type that can be decoded by codec.","ref":"EdgeDB.Protocol.CustomCodec.html#c:name/0","title":"EdgeDB.Protocol.CustomCodec.name/0","type":"callback"},{"doc":"Initialize custom codec.","ref":"EdgeDB.Protocol.CustomCodec.html#c:new/0","title":"EdgeDB.Protocol.CustomCodec.new/0","type":"callback"},{"doc":"Definition for enumerations used in EdgeDB protocol.","ref":"EdgeDB.Protocol.Enums.html","title":"EdgeDB.Protocol.Enums","type":"module"},{"doc":"Query capabilities.","ref":"EdgeDB.Protocol.Enums.html#t:capabilities/0","title":"EdgeDB.Protocol.Enums.capabilities/0","type":"type"},{"doc":"Query capabilities. Values: :readonly - query is read-only. :modifications - query is not read-only. :session_config - query contains session config change. :transaction - query contains start/commit/rollback of transaction or savepoint manipulation. :ddl - query contains DDL. :persistent_config - server or database config change. :all - all possible capabilities. :execute - capabilities to execute query.","ref":"EdgeDB.Protocol.Enums.html#t:capability/0","title":"EdgeDB.Protocol.Enums.capability/0","type":"type"},{"doc":"Cardinality of the query result. Values: :no_result - query doesn't return anything. :at_most_one - query return an optional single elements. :one - query return a single element. :many - query return a set of elements. :at_least_one - query return a set with at least of one elements.","ref":"EdgeDB.Protocol.Enums.html#t:cardinality/0","title":"EdgeDB.Protocol.Enums.cardinality/0","type":"type"},{"doc":"Compilation flags for query to extend it's features. Values: :inject_output_type_ids - inject __tid__ property as .__type__.id alias into returned objects. :inject_output_type_names - inject __tname__ property as .__type__.name alias into returned objects. :inject_output_object_ids - inject id property into returned objects.","ref":"EdgeDB.Protocol.Enums.html#t:compilation_flag/0","title":"EdgeDB.Protocol.Enums.compilation_flag/0","type":"type"},{"doc":"Compilation flags for query to extend it's features.","ref":"EdgeDB.Protocol.Enums.html#t:compilation_flags/0","title":"EdgeDB.Protocol.Enums.compilation_flags/0","type":"type"},{"doc":"Data output format. Values: :binary - return data encoded in binary. :json - return data as single row and single field that contains the result set as a single JSON array. :json_elements - return a single JSON string per top-level set element. This can be used to iterate over a large result set efficiently. :none - prevent EdgeDB from returning anything event if EdgeQL query does it.","ref":"EdgeDB.Protocol.Enums.html#t:output_format/0","title":"EdgeDB.Protocol.Enums.output_format/0","type":"type"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.AccessError type.","ref":"EdgeDB.AccessError.html","title":"EdgeDB.AccessError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AccessError type.","ref":"EdgeDB.AccessError.html#new/2","title":"EdgeDB.AccessError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.AccessPolicyError type.","ref":"EdgeDB.AccessPolicyError.html","title":"EdgeDB.AccessPolicyError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AccessPolicyError type.","ref":"EdgeDB.AccessPolicyError.html#new/2","title":"EdgeDB.AccessPolicyError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.AuthenticationError type.","ref":"EdgeDB.AuthenticationError.html","title":"EdgeDB.AuthenticationError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AuthenticationError type.","ref":"EdgeDB.AuthenticationError.html#new/2","title":"EdgeDB.AuthenticationError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.AvailabilityError type.","ref":"EdgeDB.AvailabilityError.html","title":"EdgeDB.AvailabilityError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AvailabilityError type.","ref":"EdgeDB.AvailabilityError.html#new/2","title":"EdgeDB.AvailabilityError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.BackendError type.","ref":"EdgeDB.BackendError.html","title":"EdgeDB.BackendError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.BackendError type.","ref":"EdgeDB.BackendError.html#new/2","title":"EdgeDB.BackendError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.BackendUnavailableError type.","ref":"EdgeDB.BackendUnavailableError.html","title":"EdgeDB.BackendUnavailableError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.BackendUnavailableError type.","ref":"EdgeDB.BackendUnavailableError.html#new/2","title":"EdgeDB.BackendUnavailableError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.BinaryProtocolError type.","ref":"EdgeDB.BinaryProtocolError.html","title":"EdgeDB.BinaryProtocolError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.BinaryProtocolError type.","ref":"EdgeDB.BinaryProtocolError.html#new/2","title":"EdgeDB.BinaryProtocolError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.CapabilityError type.","ref":"EdgeDB.CapabilityError.html","title":"EdgeDB.CapabilityError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.CapabilityError type.","ref":"EdgeDB.CapabilityError.html#new/2","title":"EdgeDB.CapabilityError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.CardinalityViolationError type.","ref":"EdgeDB.CardinalityViolationError.html","title":"EdgeDB.CardinalityViolationError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.CardinalityViolationError type.","ref":"EdgeDB.CardinalityViolationError.html#new/2","title":"EdgeDB.CardinalityViolationError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ClientConnectionClosedError type.","ref":"EdgeDB.ClientConnectionClosedError.html","title":"EdgeDB.ClientConnectionClosedError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionClosedError type.","ref":"EdgeDB.ClientConnectionClosedError.html#new/2","title":"EdgeDB.ClientConnectionClosedError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ClientConnectionError type.","ref":"EdgeDB.ClientConnectionError.html","title":"EdgeDB.ClientConnectionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionError type.","ref":"EdgeDB.ClientConnectionError.html#new/2","title":"EdgeDB.ClientConnectionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ClientConnectionFailedError type.","ref":"EdgeDB.ClientConnectionFailedError.html","title":"EdgeDB.ClientConnectionFailedError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionFailedError type.","ref":"EdgeDB.ClientConnectionFailedError.html#new/2","title":"EdgeDB.ClientConnectionFailedError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ClientConnectionFailedTemporarilyError type.","ref":"EdgeDB.ClientConnectionFailedTemporarilyError.html","title":"EdgeDB.ClientConnectionFailedTemporarilyError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionFailedTemporarilyError type.","ref":"EdgeDB.ClientConnectionFailedTemporarilyError.html#new/2","title":"EdgeDB.ClientConnectionFailedTemporarilyError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ClientConnectionTimeoutError type.","ref":"EdgeDB.ClientConnectionTimeoutError.html","title":"EdgeDB.ClientConnectionTimeoutError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionTimeoutError type.","ref":"EdgeDB.ClientConnectionTimeoutError.html#new/2","title":"EdgeDB.ClientConnectionTimeoutError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ClientError type.","ref":"EdgeDB.ClientError.html","title":"EdgeDB.ClientError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientError type.","ref":"EdgeDB.ClientError.html#new/2","title":"EdgeDB.ClientError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ConfigurationError type.","ref":"EdgeDB.ConfigurationError.html","title":"EdgeDB.ConfigurationError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ConfigurationError type.","ref":"EdgeDB.ConfigurationError.html#new/2","title":"EdgeDB.ConfigurationError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ConstraintViolationError type.","ref":"EdgeDB.ConstraintViolationError.html","title":"EdgeDB.ConstraintViolationError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ConstraintViolationError type.","ref":"EdgeDB.ConstraintViolationError.html#new/2","title":"EdgeDB.ConstraintViolationError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DisabledCapabilityError type.","ref":"EdgeDB.DisabledCapabilityError.html","title":"EdgeDB.DisabledCapabilityError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DisabledCapabilityError type.","ref":"EdgeDB.DisabledCapabilityError.html#new/2","title":"EdgeDB.DisabledCapabilityError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DivisionByZeroError type.","ref":"EdgeDB.DivisionByZeroError.html","title":"EdgeDB.DivisionByZeroError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DivisionByZeroError type.","ref":"EdgeDB.DivisionByZeroError.html#new/2","title":"EdgeDB.DivisionByZeroError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateCastDefinitionError type.","ref":"EdgeDB.DuplicateCastDefinitionError.html","title":"EdgeDB.DuplicateCastDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateCastDefinitionError type.","ref":"EdgeDB.DuplicateCastDefinitionError.html#new/2","title":"EdgeDB.DuplicateCastDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateConstraintDefinitionError type.","ref":"EdgeDB.DuplicateConstraintDefinitionError.html","title":"EdgeDB.DuplicateConstraintDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateConstraintDefinitionError type.","ref":"EdgeDB.DuplicateConstraintDefinitionError.html#new/2","title":"EdgeDB.DuplicateConstraintDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateDatabaseDefinitionError type.","ref":"EdgeDB.DuplicateDatabaseDefinitionError.html","title":"EdgeDB.DuplicateDatabaseDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateDatabaseDefinitionError type.","ref":"EdgeDB.DuplicateDatabaseDefinitionError.html#new/2","title":"EdgeDB.DuplicateDatabaseDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateDefinitionError type.","ref":"EdgeDB.DuplicateDefinitionError.html","title":"EdgeDB.DuplicateDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateDefinitionError type.","ref":"EdgeDB.DuplicateDefinitionError.html#new/2","title":"EdgeDB.DuplicateDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateFunctionDefinitionError type.","ref":"EdgeDB.DuplicateFunctionDefinitionError.html","title":"EdgeDB.DuplicateFunctionDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateFunctionDefinitionError type.","ref":"EdgeDB.DuplicateFunctionDefinitionError.html#new/2","title":"EdgeDB.DuplicateFunctionDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateLinkDefinitionError type.","ref":"EdgeDB.DuplicateLinkDefinitionError.html","title":"EdgeDB.DuplicateLinkDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateLinkDefinitionError type.","ref":"EdgeDB.DuplicateLinkDefinitionError.html#new/2","title":"EdgeDB.DuplicateLinkDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateModuleDefinitionError type.","ref":"EdgeDB.DuplicateModuleDefinitionError.html","title":"EdgeDB.DuplicateModuleDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateModuleDefinitionError type.","ref":"EdgeDB.DuplicateModuleDefinitionError.html#new/2","title":"EdgeDB.DuplicateModuleDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateOperatorDefinitionError type.","ref":"EdgeDB.DuplicateOperatorDefinitionError.html","title":"EdgeDB.DuplicateOperatorDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateOperatorDefinitionError type.","ref":"EdgeDB.DuplicateOperatorDefinitionError.html#new/2","title":"EdgeDB.DuplicateOperatorDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicatePropertyDefinitionError type.","ref":"EdgeDB.DuplicatePropertyDefinitionError.html","title":"EdgeDB.DuplicatePropertyDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicatePropertyDefinitionError type.","ref":"EdgeDB.DuplicatePropertyDefinitionError.html#new/2","title":"EdgeDB.DuplicatePropertyDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateUserDefinitionError type.","ref":"EdgeDB.DuplicateUserDefinitionError.html","title":"EdgeDB.DuplicateUserDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateUserDefinitionError type.","ref":"EdgeDB.DuplicateUserDefinitionError.html#new/2","title":"EdgeDB.DuplicateUserDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.DuplicateViewDefinitionError type.","ref":"EdgeDB.DuplicateViewDefinitionError.html","title":"EdgeDB.DuplicateViewDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateViewDefinitionError type.","ref":"EdgeDB.DuplicateViewDefinitionError.html#new/2","title":"EdgeDB.DuplicateViewDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.EdgeQLSyntaxError type.","ref":"EdgeDB.EdgeQLSyntaxError.html","title":"EdgeDB.EdgeQLSyntaxError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.EdgeQLSyntaxError type.","ref":"EdgeDB.EdgeQLSyntaxError.html#new/2","title":"EdgeDB.EdgeQLSyntaxError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ExecutionError type.","ref":"EdgeDB.ExecutionError.html","title":"EdgeDB.ExecutionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ExecutionError type.","ref":"EdgeDB.ExecutionError.html#new/2","title":"EdgeDB.ExecutionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.GraphQLSyntaxError type.","ref":"EdgeDB.GraphQLSyntaxError.html","title":"EdgeDB.GraphQLSyntaxError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.GraphQLSyntaxError type.","ref":"EdgeDB.GraphQLSyntaxError.html#new/2","title":"EdgeDB.GraphQLSyntaxError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.IdleSessionTimeoutError type.","ref":"EdgeDB.IdleSessionTimeoutError.html","title":"EdgeDB.IdleSessionTimeoutError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.IdleSessionTimeoutError type.","ref":"EdgeDB.IdleSessionTimeoutError.html#new/2","title":"EdgeDB.IdleSessionTimeoutError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.IdleTransactionTimeoutError type.","ref":"EdgeDB.IdleTransactionTimeoutError.html","title":"EdgeDB.IdleTransactionTimeoutError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.IdleTransactionTimeoutError type.","ref":"EdgeDB.IdleTransactionTimeoutError.html#new/2","title":"EdgeDB.IdleTransactionTimeoutError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InputDataError type.","ref":"EdgeDB.InputDataError.html","title":"EdgeDB.InputDataError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InputDataError type.","ref":"EdgeDB.InputDataError.html#new/2","title":"EdgeDB.InputDataError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.IntegrityError type.","ref":"EdgeDB.IntegrityError.html","title":"EdgeDB.IntegrityError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.IntegrityError type.","ref":"EdgeDB.IntegrityError.html#new/2","title":"EdgeDB.IntegrityError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InterfaceError type.","ref":"EdgeDB.InterfaceError.html","title":"EdgeDB.InterfaceError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InterfaceError type.","ref":"EdgeDB.InterfaceError.html#new/2","title":"EdgeDB.InterfaceError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InternalClientError type.","ref":"EdgeDB.InternalClientError.html","title":"EdgeDB.InternalClientError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InternalClientError type.","ref":"EdgeDB.InternalClientError.html#new/2","title":"EdgeDB.InternalClientError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InternalServerError type.","ref":"EdgeDB.InternalServerError.html","title":"EdgeDB.InternalServerError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InternalServerError type.","ref":"EdgeDB.InternalServerError.html#new/2","title":"EdgeDB.InternalServerError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidAliasDefinitionError type.","ref":"EdgeDB.InvalidAliasDefinitionError.html","title":"EdgeDB.InvalidAliasDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidAliasDefinitionError type.","ref":"EdgeDB.InvalidAliasDefinitionError.html#new/2","title":"EdgeDB.InvalidAliasDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidArgumentError type.","ref":"EdgeDB.InvalidArgumentError.html","title":"EdgeDB.InvalidArgumentError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidArgumentError type.","ref":"EdgeDB.InvalidArgumentError.html#new/2","title":"EdgeDB.InvalidArgumentError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidCastDefinitionError type.","ref":"EdgeDB.InvalidCastDefinitionError.html","title":"EdgeDB.InvalidCastDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidCastDefinitionError type.","ref":"EdgeDB.InvalidCastDefinitionError.html#new/2","title":"EdgeDB.InvalidCastDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidConstraintDefinitionError type.","ref":"EdgeDB.InvalidConstraintDefinitionError.html","title":"EdgeDB.InvalidConstraintDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidConstraintDefinitionError type.","ref":"EdgeDB.InvalidConstraintDefinitionError.html#new/2","title":"EdgeDB.InvalidConstraintDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidDatabaseDefinitionError type.","ref":"EdgeDB.InvalidDatabaseDefinitionError.html","title":"EdgeDB.InvalidDatabaseDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidDatabaseDefinitionError type.","ref":"EdgeDB.InvalidDatabaseDefinitionError.html#new/2","title":"EdgeDB.InvalidDatabaseDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidDefinitionError type.","ref":"EdgeDB.InvalidDefinitionError.html","title":"EdgeDB.InvalidDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidDefinitionError type.","ref":"EdgeDB.InvalidDefinitionError.html#new/2","title":"EdgeDB.InvalidDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidFunctionDefinitionError type.","ref":"EdgeDB.InvalidFunctionDefinitionError.html","title":"EdgeDB.InvalidFunctionDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidFunctionDefinitionError type.","ref":"EdgeDB.InvalidFunctionDefinitionError.html#new/2","title":"EdgeDB.InvalidFunctionDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidLinkDefinitionError type.","ref":"EdgeDB.InvalidLinkDefinitionError.html","title":"EdgeDB.InvalidLinkDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidLinkDefinitionError type.","ref":"EdgeDB.InvalidLinkDefinitionError.html#new/2","title":"EdgeDB.InvalidLinkDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidLinkTargetError type.","ref":"EdgeDB.InvalidLinkTargetError.html","title":"EdgeDB.InvalidLinkTargetError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidLinkTargetError type.","ref":"EdgeDB.InvalidLinkTargetError.html#new/2","title":"EdgeDB.InvalidLinkTargetError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidModuleDefinitionError type.","ref":"EdgeDB.InvalidModuleDefinitionError.html","title":"EdgeDB.InvalidModuleDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidModuleDefinitionError type.","ref":"EdgeDB.InvalidModuleDefinitionError.html#new/2","title":"EdgeDB.InvalidModuleDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidOperatorDefinitionError type.","ref":"EdgeDB.InvalidOperatorDefinitionError.html","title":"EdgeDB.InvalidOperatorDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidOperatorDefinitionError type.","ref":"EdgeDB.InvalidOperatorDefinitionError.html#new/2","title":"EdgeDB.InvalidOperatorDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidPropertyDefinitionError type.","ref":"EdgeDB.InvalidPropertyDefinitionError.html","title":"EdgeDB.InvalidPropertyDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidPropertyDefinitionError type.","ref":"EdgeDB.InvalidPropertyDefinitionError.html#new/2","title":"EdgeDB.InvalidPropertyDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidPropertyTargetError type.","ref":"EdgeDB.InvalidPropertyTargetError.html","title":"EdgeDB.InvalidPropertyTargetError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidPropertyTargetError type.","ref":"EdgeDB.InvalidPropertyTargetError.html#new/2","title":"EdgeDB.InvalidPropertyTargetError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidReferenceError type.","ref":"EdgeDB.InvalidReferenceError.html","title":"EdgeDB.InvalidReferenceError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidReferenceError type.","ref":"EdgeDB.InvalidReferenceError.html#new/2","title":"EdgeDB.InvalidReferenceError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidSyntaxError type.","ref":"EdgeDB.InvalidSyntaxError.html","title":"EdgeDB.InvalidSyntaxError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidSyntaxError type.","ref":"EdgeDB.InvalidSyntaxError.html#new/2","title":"EdgeDB.InvalidSyntaxError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidTargetError type.","ref":"EdgeDB.InvalidTargetError.html","title":"EdgeDB.InvalidTargetError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidTargetError type.","ref":"EdgeDB.InvalidTargetError.html#new/2","title":"EdgeDB.InvalidTargetError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidTypeError type.","ref":"EdgeDB.InvalidTypeError.html","title":"EdgeDB.InvalidTypeError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidTypeError type.","ref":"EdgeDB.InvalidTypeError.html#new/2","title":"EdgeDB.InvalidTypeError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidUserDefinitionError type.","ref":"EdgeDB.InvalidUserDefinitionError.html","title":"EdgeDB.InvalidUserDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidUserDefinitionError type.","ref":"EdgeDB.InvalidUserDefinitionError.html#new/2","title":"EdgeDB.InvalidUserDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.InvalidValueError type.","ref":"EdgeDB.InvalidValueError.html","title":"EdgeDB.InvalidValueError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidValueError type.","ref":"EdgeDB.InvalidValueError.html#new/2","title":"EdgeDB.InvalidValueError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.LogMessage type.","ref":"EdgeDB.LogMessage.html","title":"EdgeDB.LogMessage","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.LogMessage type.","ref":"EdgeDB.LogMessage.html#new/2","title":"EdgeDB.LogMessage.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.MissingArgumentError type.","ref":"EdgeDB.MissingArgumentError.html","title":"EdgeDB.MissingArgumentError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.MissingArgumentError type.","ref":"EdgeDB.MissingArgumentError.html#new/2","title":"EdgeDB.MissingArgumentError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.MissingRequiredError type.","ref":"EdgeDB.MissingRequiredError.html","title":"EdgeDB.MissingRequiredError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.MissingRequiredError type.","ref":"EdgeDB.MissingRequiredError.html#new/2","title":"EdgeDB.MissingRequiredError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.NoDataError type.","ref":"EdgeDB.NoDataError.html","title":"EdgeDB.NoDataError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.NoDataError type.","ref":"EdgeDB.NoDataError.html#new/2","title":"EdgeDB.NoDataError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.NumericOutOfRangeError type.","ref":"EdgeDB.NumericOutOfRangeError.html","title":"EdgeDB.NumericOutOfRangeError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.NumericOutOfRangeError type.","ref":"EdgeDB.NumericOutOfRangeError.html#new/2","title":"EdgeDB.NumericOutOfRangeError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ParameterTypeMismatchError type.","ref":"EdgeDB.ParameterTypeMismatchError.html","title":"EdgeDB.ParameterTypeMismatchError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ParameterTypeMismatchError type.","ref":"EdgeDB.ParameterTypeMismatchError.html#new/2","title":"EdgeDB.ParameterTypeMismatchError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ProtocolError type.","ref":"EdgeDB.ProtocolError.html","title":"EdgeDB.ProtocolError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ProtocolError type.","ref":"EdgeDB.ProtocolError.html#new/2","title":"EdgeDB.ProtocolError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.QueryArgumentError type.","ref":"EdgeDB.QueryArgumentError.html","title":"EdgeDB.QueryArgumentError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.QueryArgumentError type.","ref":"EdgeDB.QueryArgumentError.html#new/2","title":"EdgeDB.QueryArgumentError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.QueryError type.","ref":"EdgeDB.QueryError.html","title":"EdgeDB.QueryError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.QueryError type.","ref":"EdgeDB.QueryError.html#new/2","title":"EdgeDB.QueryError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.QueryTimeoutError type.","ref":"EdgeDB.QueryTimeoutError.html","title":"EdgeDB.QueryTimeoutError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.QueryTimeoutError type.","ref":"EdgeDB.QueryTimeoutError.html#new/2","title":"EdgeDB.QueryTimeoutError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.ResultCardinalityMismatchError type.","ref":"EdgeDB.ResultCardinalityMismatchError.html","title":"EdgeDB.ResultCardinalityMismatchError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ResultCardinalityMismatchError type.","ref":"EdgeDB.ResultCardinalityMismatchError.html#new/2","title":"EdgeDB.ResultCardinalityMismatchError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.SchemaDefinitionError type.","ref":"EdgeDB.SchemaDefinitionError.html","title":"EdgeDB.SchemaDefinitionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SchemaDefinitionError type.","ref":"EdgeDB.SchemaDefinitionError.html#new/2","title":"EdgeDB.SchemaDefinitionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.SchemaError type.","ref":"EdgeDB.SchemaError.html","title":"EdgeDB.SchemaError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SchemaError type.","ref":"EdgeDB.SchemaError.html#new/2","title":"EdgeDB.SchemaError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.SchemaSyntaxError type.","ref":"EdgeDB.SchemaSyntaxError.html","title":"EdgeDB.SchemaSyntaxError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SchemaSyntaxError type.","ref":"EdgeDB.SchemaSyntaxError.html#new/2","title":"EdgeDB.SchemaSyntaxError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.SessionTimeoutError type.","ref":"EdgeDB.SessionTimeoutError.html","title":"EdgeDB.SessionTimeoutError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SessionTimeoutError type.","ref":"EdgeDB.SessionTimeoutError.html#new/2","title":"EdgeDB.SessionTimeoutError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.StateMismatchError type.","ref":"EdgeDB.StateMismatchError.html","title":"EdgeDB.StateMismatchError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.StateMismatchError type.","ref":"EdgeDB.StateMismatchError.html#new/2","title":"EdgeDB.StateMismatchError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.TransactionConflictError type.","ref":"EdgeDB.TransactionConflictError.html","title":"EdgeDB.TransactionConflictError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionConflictError type.","ref":"EdgeDB.TransactionConflictError.html#new/2","title":"EdgeDB.TransactionConflictError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.TransactionDeadlockError type.","ref":"EdgeDB.TransactionDeadlockError.html","title":"EdgeDB.TransactionDeadlockError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionDeadlockError type.","ref":"EdgeDB.TransactionDeadlockError.html#new/2","title":"EdgeDB.TransactionDeadlockError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.TransactionError type.","ref":"EdgeDB.TransactionError.html","title":"EdgeDB.TransactionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionError type.","ref":"EdgeDB.TransactionError.html#new/2","title":"EdgeDB.TransactionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.TransactionSerializationError type.","ref":"EdgeDB.TransactionSerializationError.html","title":"EdgeDB.TransactionSerializationError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionSerializationError type.","ref":"EdgeDB.TransactionSerializationError.html#new/2","title":"EdgeDB.TransactionSerializationError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.TransactionTimeoutError type.","ref":"EdgeDB.TransactionTimeoutError.html","title":"EdgeDB.TransactionTimeoutError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionTimeoutError type.","ref":"EdgeDB.TransactionTimeoutError.html#new/2","title":"EdgeDB.TransactionTimeoutError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.TypeSpecNotFoundError type.","ref":"EdgeDB.TypeSpecNotFoundError.html","title":"EdgeDB.TypeSpecNotFoundError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TypeSpecNotFoundError type.","ref":"EdgeDB.TypeSpecNotFoundError.html#new/2","title":"EdgeDB.TypeSpecNotFoundError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnexpectedMessageError type.","ref":"EdgeDB.UnexpectedMessageError.html","title":"EdgeDB.UnexpectedMessageError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnexpectedMessageError type.","ref":"EdgeDB.UnexpectedMessageError.html#new/2","title":"EdgeDB.UnexpectedMessageError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnknownArgumentError type.","ref":"EdgeDB.UnknownArgumentError.html","title":"EdgeDB.UnknownArgumentError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownArgumentError type.","ref":"EdgeDB.UnknownArgumentError.html#new/2","title":"EdgeDB.UnknownArgumentError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnknownDatabaseError type.","ref":"EdgeDB.UnknownDatabaseError.html","title":"EdgeDB.UnknownDatabaseError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownDatabaseError type.","ref":"EdgeDB.UnknownDatabaseError.html#new/2","title":"EdgeDB.UnknownDatabaseError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnknownLinkError type.","ref":"EdgeDB.UnknownLinkError.html","title":"EdgeDB.UnknownLinkError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownLinkError type.","ref":"EdgeDB.UnknownLinkError.html#new/2","title":"EdgeDB.UnknownLinkError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnknownModuleError type.","ref":"EdgeDB.UnknownModuleError.html","title":"EdgeDB.UnknownModuleError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownModuleError type.","ref":"EdgeDB.UnknownModuleError.html#new/2","title":"EdgeDB.UnknownModuleError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnknownParameterError type.","ref":"EdgeDB.UnknownParameterError.html","title":"EdgeDB.UnknownParameterError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownParameterError type.","ref":"EdgeDB.UnknownParameterError.html#new/2","title":"EdgeDB.UnknownParameterError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnknownPropertyError type.","ref":"EdgeDB.UnknownPropertyError.html","title":"EdgeDB.UnknownPropertyError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownPropertyError type.","ref":"EdgeDB.UnknownPropertyError.html#new/2","title":"EdgeDB.UnknownPropertyError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnknownUserError type.","ref":"EdgeDB.UnknownUserError.html","title":"EdgeDB.UnknownUserError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownUserError type.","ref":"EdgeDB.UnknownUserError.html#new/2","title":"EdgeDB.UnknownUserError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnsupportedBackendFeatureError type.","ref":"EdgeDB.UnsupportedBackendFeatureError.html","title":"EdgeDB.UnsupportedBackendFeatureError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedBackendFeatureError type.","ref":"EdgeDB.UnsupportedBackendFeatureError.html#new/2","title":"EdgeDB.UnsupportedBackendFeatureError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnsupportedCapabilityError type.","ref":"EdgeDB.UnsupportedCapabilityError.html","title":"EdgeDB.UnsupportedCapabilityError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedCapabilityError type.","ref":"EdgeDB.UnsupportedCapabilityError.html#new/2","title":"EdgeDB.UnsupportedCapabilityError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnsupportedFeatureError type.","ref":"EdgeDB.UnsupportedFeatureError.html","title":"EdgeDB.UnsupportedFeatureError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedFeatureError type.","ref":"EdgeDB.UnsupportedFeatureError.html#new/2","title":"EdgeDB.UnsupportedFeatureError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.UnsupportedProtocolVersionError type.","ref":"EdgeDB.UnsupportedProtocolVersionError.html","title":"EdgeDB.UnsupportedProtocolVersionError","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedProtocolVersionError type.","ref":"EdgeDB.UnsupportedProtocolVersionError.html#new/2","title":"EdgeDB.UnsupportedProtocolVersionError.new/2","type":"function"},{"doc":"A shorthand module to create EdgeDB.Error of EdgeDB.WarningMessage type.","ref":"EdgeDB.WarningMessage.html","title":"EdgeDB.WarningMessage","type":"module"},{"doc":"Create a new EdgeDB.Error with EdgeDB.WarningMessage type.","ref":"EdgeDB.WarningMessage.html#new/2","title":"EdgeDB.WarningMessage.new/2","type":"function"},{"doc":"Exception returned by the client if an error occurred. Most of the functions in the EdgeDB.Error module are a shorthands for simplifying EdgeDB.Error exception constructing. These functions are generated at compile time from a copy of the errors.txt file. The useful ones are: EdgeDB.Error.retry?/1 EdgeDB.Error.inheritor?/2","ref":"EdgeDB.Error.html","title":"EdgeDB.Error","type":"exception"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AccessError type.","ref":"EdgeDB.Error.html#access_error/2","title":"EdgeDB.Error.access_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AccessPolicyError type.","ref":"EdgeDB.Error.html#access_policy_error/2","title":"EdgeDB.Error.access_policy_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AuthenticationError type.","ref":"EdgeDB.Error.html#authentication_error/2","title":"EdgeDB.Error.authentication_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.AvailabilityError type.","ref":"EdgeDB.Error.html#availability_error/2","title":"EdgeDB.Error.availability_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.BackendError type.","ref":"EdgeDB.Error.html#backend_error/2","title":"EdgeDB.Error.backend_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.BackendUnavailableError type.","ref":"EdgeDB.Error.html#backend_unavailable_error/2","title":"EdgeDB.Error.backend_unavailable_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.BinaryProtocolError type.","ref":"EdgeDB.Error.html#binary_protocol_error/2","title":"EdgeDB.Error.binary_protocol_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.CapabilityError type.","ref":"EdgeDB.Error.html#capability_error/2","title":"EdgeDB.Error.capability_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.CardinalityViolationError type.","ref":"EdgeDB.Error.html#cardinality_violation_error/2","title":"EdgeDB.Error.cardinality_violation_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionClosedError type.","ref":"EdgeDB.Error.html#client_connection_closed_error/2","title":"EdgeDB.Error.client_connection_closed_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionError type.","ref":"EdgeDB.Error.html#client_connection_error/2","title":"EdgeDB.Error.client_connection_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionFailedError type.","ref":"EdgeDB.Error.html#client_connection_failed_error/2","title":"EdgeDB.Error.client_connection_failed_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionFailedTemporarilyError type.","ref":"EdgeDB.Error.html#client_connection_failed_temporarily_error/2","title":"EdgeDB.Error.client_connection_failed_temporarily_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientConnectionTimeoutError type.","ref":"EdgeDB.Error.html#client_connection_timeout_error/2","title":"EdgeDB.Error.client_connection_timeout_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ClientError type.","ref":"EdgeDB.Error.html#client_error/2","title":"EdgeDB.Error.client_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ConfigurationError type.","ref":"EdgeDB.Error.html#configuration_error/2","title":"EdgeDB.Error.configuration_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ConstraintViolationError type.","ref":"EdgeDB.Error.html#constraint_violation_error/2","title":"EdgeDB.Error.constraint_violation_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DisabledCapabilityError type.","ref":"EdgeDB.Error.html#disabled_capability_error/2","title":"EdgeDB.Error.disabled_capability_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DivisionByZeroError type.","ref":"EdgeDB.Error.html#division_by_zero_error/2","title":"EdgeDB.Error.division_by_zero_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateCastDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_cast_definition_error/2","title":"EdgeDB.Error.duplicate_cast_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateConstraintDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_constraint_definition_error/2","title":"EdgeDB.Error.duplicate_constraint_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateDatabaseDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_database_definition_error/2","title":"EdgeDB.Error.duplicate_database_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_definition_error/2","title":"EdgeDB.Error.duplicate_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateFunctionDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_function_definition_error/2","title":"EdgeDB.Error.duplicate_function_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateLinkDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_link_definition_error/2","title":"EdgeDB.Error.duplicate_link_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateModuleDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_module_definition_error/2","title":"EdgeDB.Error.duplicate_module_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateOperatorDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_operator_definition_error/2","title":"EdgeDB.Error.duplicate_operator_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicatePropertyDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_property_definition_error/2","title":"EdgeDB.Error.duplicate_property_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateUserDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_user_definition_error/2","title":"EdgeDB.Error.duplicate_user_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.DuplicateViewDefinitionError type.","ref":"EdgeDB.Error.html#duplicate_view_definition_error/2","title":"EdgeDB.Error.duplicate_view_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.EdgeQLSyntaxError type.","ref":"EdgeDB.Error.html#edge_ql_syntax_error/2","title":"EdgeDB.Error.edge_ql_syntax_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ExecutionError type.","ref":"EdgeDB.Error.html#execution_error/2","title":"EdgeDB.Error.execution_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.GraphQLSyntaxError type.","ref":"EdgeDB.Error.html#graph_ql_syntax_error/2","title":"EdgeDB.Error.graph_ql_syntax_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.IdleSessionTimeoutError type.","ref":"EdgeDB.Error.html#idle_session_timeout_error/2","title":"EdgeDB.Error.idle_session_timeout_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.IdleTransactionTimeoutError type.","ref":"EdgeDB.Error.html#idle_transaction_timeout_error/2","title":"EdgeDB.Error.idle_transaction_timeout_error/2","type":"function"},{"doc":"Check if the exception is an inheritor of another EdgeDB error.","ref":"EdgeDB.Error.html#inheritor?/2","title":"EdgeDB.Error.inheritor?/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InputDataError type.","ref":"EdgeDB.Error.html#input_data_error/2","title":"EdgeDB.Error.input_data_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.IntegrityError type.","ref":"EdgeDB.Error.html#integrity_error/2","title":"EdgeDB.Error.integrity_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InterfaceError type.","ref":"EdgeDB.Error.html#interface_error/2","title":"EdgeDB.Error.interface_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InternalClientError type.","ref":"EdgeDB.Error.html#internal_client_error/2","title":"EdgeDB.Error.internal_client_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InternalServerError type.","ref":"EdgeDB.Error.html#internal_server_error/2","title":"EdgeDB.Error.internal_server_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidAliasDefinitionError type.","ref":"EdgeDB.Error.html#invalid_alias_definition_error/2","title":"EdgeDB.Error.invalid_alias_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidArgumentError type.","ref":"EdgeDB.Error.html#invalid_argument_error/2","title":"EdgeDB.Error.invalid_argument_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidCastDefinitionError type.","ref":"EdgeDB.Error.html#invalid_cast_definition_error/2","title":"EdgeDB.Error.invalid_cast_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidConstraintDefinitionError type.","ref":"EdgeDB.Error.html#invalid_constraint_definition_error/2","title":"EdgeDB.Error.invalid_constraint_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidDatabaseDefinitionError type.","ref":"EdgeDB.Error.html#invalid_database_definition_error/2","title":"EdgeDB.Error.invalid_database_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidDefinitionError type.","ref":"EdgeDB.Error.html#invalid_definition_error/2","title":"EdgeDB.Error.invalid_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidFunctionDefinitionError type.","ref":"EdgeDB.Error.html#invalid_function_definition_error/2","title":"EdgeDB.Error.invalid_function_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidLinkDefinitionError type.","ref":"EdgeDB.Error.html#invalid_link_definition_error/2","title":"EdgeDB.Error.invalid_link_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidLinkTargetError type.","ref":"EdgeDB.Error.html#invalid_link_target_error/2","title":"EdgeDB.Error.invalid_link_target_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidModuleDefinitionError type.","ref":"EdgeDB.Error.html#invalid_module_definition_error/2","title":"EdgeDB.Error.invalid_module_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidOperatorDefinitionError type.","ref":"EdgeDB.Error.html#invalid_operator_definition_error/2","title":"EdgeDB.Error.invalid_operator_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidPropertyDefinitionError type.","ref":"EdgeDB.Error.html#invalid_property_definition_error/2","title":"EdgeDB.Error.invalid_property_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidPropertyTargetError type.","ref":"EdgeDB.Error.html#invalid_property_target_error/2","title":"EdgeDB.Error.invalid_property_target_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidReferenceError type.","ref":"EdgeDB.Error.html#invalid_reference_error/2","title":"EdgeDB.Error.invalid_reference_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidSyntaxError type.","ref":"EdgeDB.Error.html#invalid_syntax_error/2","title":"EdgeDB.Error.invalid_syntax_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidTargetError type.","ref":"EdgeDB.Error.html#invalid_target_error/2","title":"EdgeDB.Error.invalid_target_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidTypeError type.","ref":"EdgeDB.Error.html#invalid_type_error/2","title":"EdgeDB.Error.invalid_type_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidUserDefinitionError type.","ref":"EdgeDB.Error.html#invalid_user_definition_error/2","title":"EdgeDB.Error.invalid_user_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.InvalidValueError type.","ref":"EdgeDB.Error.html#invalid_value_error/2","title":"EdgeDB.Error.invalid_value_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.LogMessage type.","ref":"EdgeDB.Error.html#log_message/2","title":"EdgeDB.Error.log_message/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.MissingArgumentError type.","ref":"EdgeDB.Error.html#missing_argument_error/2","title":"EdgeDB.Error.missing_argument_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.MissingRequiredError type.","ref":"EdgeDB.Error.html#missing_required_error/2","title":"EdgeDB.Error.missing_required_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.NoDataError type.","ref":"EdgeDB.Error.html#no_data_error/2","title":"EdgeDB.Error.no_data_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.NumericOutOfRangeError type.","ref":"EdgeDB.Error.html#numeric_out_of_range_error/2","title":"EdgeDB.Error.numeric_out_of_range_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ParameterTypeMismatchError type.","ref":"EdgeDB.Error.html#parameter_type_mismatch_error/2","title":"EdgeDB.Error.parameter_type_mismatch_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ProtocolError type.","ref":"EdgeDB.Error.html#protocol_error/2","title":"EdgeDB.Error.protocol_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.QueryArgumentError type.","ref":"EdgeDB.Error.html#query_argument_error/2","title":"EdgeDB.Error.query_argument_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.QueryError type.","ref":"EdgeDB.Error.html#query_error/2","title":"EdgeDB.Error.query_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.QueryTimeoutError type.","ref":"EdgeDB.Error.html#query_timeout_error/2","title":"EdgeDB.Error.query_timeout_error/2","type":"function"},{"doc":"Check if should try to reconnect to EdgeDB server. NOTE : this function is not used right now, because DBConnection reconnects it connection itself.","ref":"EdgeDB.Error.html#reconnect?/1","title":"EdgeDB.Error.reconnect?/1","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.ResultCardinalityMismatchError type.","ref":"EdgeDB.Error.html#result_cardinality_mismatch_error/2","title":"EdgeDB.Error.result_cardinality_mismatch_error/2","type":"function"},{"doc":"Check if should try to repeat the query during the execution of which an error occurred.","ref":"EdgeDB.Error.html#retry?/1","title":"EdgeDB.Error.retry?/1","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SchemaDefinitionError type.","ref":"EdgeDB.Error.html#schema_definition_error/2","title":"EdgeDB.Error.schema_definition_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SchemaError type.","ref":"EdgeDB.Error.html#schema_error/2","title":"EdgeDB.Error.schema_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SchemaSyntaxError type.","ref":"EdgeDB.Error.html#schema_syntax_error/2","title":"EdgeDB.Error.schema_syntax_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.SessionTimeoutError type.","ref":"EdgeDB.Error.html#session_timeout_error/2","title":"EdgeDB.Error.session_timeout_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.StateMismatchError type.","ref":"EdgeDB.Error.html#state_mismatch_error/2","title":"EdgeDB.Error.state_mismatch_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionConflictError type.","ref":"EdgeDB.Error.html#transaction_conflict_error/2","title":"EdgeDB.Error.transaction_conflict_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionDeadlockError type.","ref":"EdgeDB.Error.html#transaction_deadlock_error/2","title":"EdgeDB.Error.transaction_deadlock_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionError type.","ref":"EdgeDB.Error.html#transaction_error/2","title":"EdgeDB.Error.transaction_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionSerializationError type.","ref":"EdgeDB.Error.html#transaction_serialization_error/2","title":"EdgeDB.Error.transaction_serialization_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TransactionTimeoutError type.","ref":"EdgeDB.Error.html#transaction_timeout_error/2","title":"EdgeDB.Error.transaction_timeout_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.TypeSpecNotFoundError type.","ref":"EdgeDB.Error.html#type_spec_not_found_error/2","title":"EdgeDB.Error.type_spec_not_found_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnexpectedMessageError type.","ref":"EdgeDB.Error.html#unexpected_message_error/2","title":"EdgeDB.Error.unexpected_message_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownArgumentError type.","ref":"EdgeDB.Error.html#unknown_argument_error/2","title":"EdgeDB.Error.unknown_argument_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownDatabaseError type.","ref":"EdgeDB.Error.html#unknown_database_error/2","title":"EdgeDB.Error.unknown_database_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownLinkError type.","ref":"EdgeDB.Error.html#unknown_link_error/2","title":"EdgeDB.Error.unknown_link_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownModuleError type.","ref":"EdgeDB.Error.html#unknown_module_error/2","title":"EdgeDB.Error.unknown_module_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownParameterError type.","ref":"EdgeDB.Error.html#unknown_parameter_error/2","title":"EdgeDB.Error.unknown_parameter_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownPropertyError type.","ref":"EdgeDB.Error.html#unknown_property_error/2","title":"EdgeDB.Error.unknown_property_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnknownUserError type.","ref":"EdgeDB.Error.html#unknown_user_error/2","title":"EdgeDB.Error.unknown_user_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedBackendFeatureError type.","ref":"EdgeDB.Error.html#unsupported_backend_feature_error/2","title":"EdgeDB.Error.unsupported_backend_feature_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedCapabilityError type.","ref":"EdgeDB.Error.html#unsupported_capability_error/2","title":"EdgeDB.Error.unsupported_capability_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedFeatureError type.","ref":"EdgeDB.Error.html#unsupported_feature_error/2","title":"EdgeDB.Error.unsupported_feature_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.UnsupportedProtocolVersionError type.","ref":"EdgeDB.Error.html#unsupported_protocol_version_error/2","title":"EdgeDB.Error.unsupported_protocol_version_error/2","type":"function"},{"doc":"Create a new EdgeDB.Error with EdgeDB.WarningMessage type.","ref":"EdgeDB.Error.html#warning_message/2","title":"EdgeDB.Error.warning_message/2","type":"function"},{"doc":"Exception returned by the client if an error occurred. Fields: :message - human-readable error message. :type - alias module for EdgeDB error. :name - error name from EdgeDB. :code - internal error code.","ref":"EdgeDB.Error.html#t:t/0","title":"EdgeDB.Error.t/0","type":"type"},{"doc":"edgedb-elixir is the EdgeDB client for Elixir.","ref":"main.html","title":"EdgeDB client for Elixir","type":"extras"},{"doc":"edgedb-elixir is available in hex.pm and can be installed via mix . Just add :edgedb to your dependencies in the mix.exs file: { :edgedb , &quot;~&gt; 0.1&quot; }","ref":"main.html#installation","title":"EdgeDB client for Elixir - Installation","type":"extras"},{"doc":"EdgeDB comes with JSON support out of the box via the Jason library. To use it, add :jason to your dependencies in the mix.exs file: { :jason , &quot;~&gt; 1.0&quot; } The JSON library can be configured using the :json option in the :edgedb application configuration: config :edgedb , json : CustomJSONLibrary The JSON library is injected in the compiled EdgeDB code, so be sure to recompile EdgeDB if you change it: mix deps.clean edgedb --build","ref":"main.html#json-support","title":"EdgeDB client for Elixir - JSON support","type":"extras"},{"doc":"EdgeDB can work with Timex out of the box. If you define Timex as an application dependency, EdgeDB will use Timex.Duration to encode and decode the std::duration type from database. If you don't like this behavior, you can set EdgeDB to ignore Timex using the :timex_duration option by setting this to false in the :edgedb application configuration: config :edgedb , timex_duration : false EdgeDB will inject the use of Timex into the std::duration codec at compile time, so be sure to recompile EdgeDB if you change this behavior: mix deps.clean edgedb --build","ref":"main.html#timex-support","title":"EdgeDB client for Elixir - Timex support","type":"extras"},{"doc":"This project is licensed under the terms of the Apache 2.0 license. See LICENSE for details.","ref":"main.html#license","title":"EdgeDB client for Elixir - License","type":"extras"},{"doc":"The basic user API for edgedb-elixir is provided by the EdgeDB module and in most cases you will use only it. The exception is when you want to define custom codecs . EdgeDB provides several functions for querying data from the database, which are named in EdgeDB.query*/4 format. Transactions are supported with EdgeDB.transaction/3 function.","ref":"usage.html","title":"Usage","type":"extras"},{"doc":"edgedb-elixir , like official clients, allows a very flexible way to define how to connect to an instance. For more information, see EdgeDB.connect_option/0 . The examples on this page will involve connecting to an instance using edgedb projects . Run edgedb project init to initialize the project: edgedb project init Database schema Ensure that your database has the following schema: module default { type User { required property name -&gt; str { constraint exclusive; }; } type Post { required property body -&gt; str; required link author -&gt; User; multi link comments -&gt; Post; } }; Let's fill the database with some data, which will be used in further examples: iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; EdgeDB . query! ( client , &quot; ...(2)&gt; WITH ...(2)&gt; p1 := ( ...(2)&gt; insert Post { ...(2)&gt; body := &#39;Yes!&#39;, ...(2)&gt; author := ( ...(2)&gt; insert User { ...(2)&gt; name := &#39;commentator1&#39; ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; } ...(2)&gt; ), ...(2)&gt; p2 := ( ...(2)&gt; insert Post { ...(2)&gt; body := &#39;Absolutely amazing&#39;, ...(2)&gt; author := ( ...(2)&gt; insert User { ...(2)&gt; name := &#39;commentator2&#39; ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; } ...(2)&gt; ), ...(2)&gt; p3 := ( ...(2)&gt; insert Post { ...(2)&gt; body := &#39;FYI here is a link to the Elixir client: https://hex.pm/packages/edgedb&#39;, ...(2)&gt; author := ( ...(2)&gt; insert User { ...(2)&gt; name := &#39;commentator3&#39; ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; } ...(2)&gt; ) ...(2)&gt; insert Post { ...(2)&gt; body := &#39;EdgeDB is awesome! Try the Elixir client for it&#39;, ...(2)&gt; author := ( ...(2)&gt; insert User { ...(2)&gt; name := &#39;author1&#39; ...(2)&gt; } ...(2)&gt; ), ...(2)&gt; comments := {p1, p2, p3} ...(2)&gt; } ...(2)&gt; &quot; )","ref":"usage.html#establishing-a-connection","title":"Usage - Establishing a connection","type":"extras"},{"doc":"Depending on the expected results of the query, you can use different functions to retrieve data from the database. This is called the cardinality of the result and is better explained in the official documentation . Querying a set of elements If you want to receive an EdgeDB.Set from your query, just use the EdgeDB.query/4 or EdgeDB.query!/4 functions. The difference between the two functions is that EdgeDB.query/4 will return an :ok tuple with result if successful or a :error tuple with EdgeDB.Error if an error occurred during the query execution. EdgeDB.query!/4 will return a plain result if successful or raise EdgeDB.Error if error. Let's query all existing posts with their bodies: iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , posts } = EdgeDB . query ( client , &quot;select Post { body }&quot; ) { :ok , # EdgeDB.Set &lt; { # EdgeDB.Object &lt; body := &quot;EdgeDB is awesome! Try the Elixir client for it&quot; &gt; , # EdgeDB.Object &lt; body := &quot;Yes!&quot; &gt; , # EdgeDB.Object &lt; body := &quot;Absolutely amazing&quot; &gt; , # EdgeDB.Object &lt; body := &quot;FYI here is a link to the Elixir client: https://hex.pm/packages/edgedb&quot; &gt; } &gt; } We can iterate over EdgeDB.Set and inspect each object separately: iex(3)&gt; Enum . each ( posts , fn % EdgeDB.Object { } = post -&gt; ...(3)&gt; IO . inspect ( post [ :body ] , label : &quot;post ( \#{ inspect ( post . id ) } )&quot; ) ...(3)&gt; end ) post ( &quot;3c5c8cf2-860f-11ec-a22a-2b0ab4e21d4b&quot; ) : &quot;EdgeDB is awesome! Try the Elixir client for it&quot; post ( &quot;3c5c904e-860f-11ec-a22a-f7cdb9bcb510&quot; ) : &quot;Yes!&quot; post ( &quot;3c5c9256-860f-11ec-a22a-0343fa0961f3&quot; ) : &quot;Absolutely amazing&quot; post ( &quot;3c5c9378-860f-11ec-a22a-0713dfca8baa&quot; ) : &quot;FYI here is a link to the Elixir client: https://hex.pm/packages/edgedb&quot; :ok Querying a single element If you know that the query will return only one element or none, you can use EdgeDB.query_single/4 and EdgeDB.query_single!/4 functions. This function will automatically unpack the underlying EdgeDB.Set and return the requested item (or nil if the set is empty). Let's query a post with a link to the Elixir client for EdgeDB: iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; % EdgeDB.Object { } = post = EdgeDB . query_single! ( client , &quot;select Post filter contains(.body, &#39;https://hex.pm/packages/edgedb&#39;) limit 1&quot; ) iex(3)&gt; post . id &quot;3c5c9378-860f-11ec-a22a-0713dfca8baa&quot; If we try to select a Post that does not exist, nil will be returned: iex(4)&gt; EdgeDB . query_single! ( client , &quot;select Post filter .body = &#39;lol&#39; limit 1&quot; ) nil Querying a required single element In case we want to ensure that the requested element must exist, we can use the functions EdgeDB.query_required_single/4 and EdgeDB.query_required_single!/4 . Instead of returning nil they will return EdgeDB.Error in case of a missing element: iex(5)&gt; EdgeDB . query_required_single! ( client , &quot;select Post filter .body = &#39;lol&#39; limit 1&quot; ) ** (EdgeDB.Error) NoDataError: expected result, but query did not return any data","ref":"usage.html#querying-data-from-edgedb","title":"Usage - Querying data from EdgeDB","type":"extras"},{"doc":"NOTE Note that EdgeDB.transaction/3 calls can not be nested. The API for transactions is provided by the EdgeDB.transaction/3 function: iex(1)&gt; { :ok , client } = EdgeDB . start_link ( ) iex(2)&gt; { :ok , user } = ...(2)&gt; EdgeDB . transaction ( client , fn conn -&gt; ...(2)&gt; EdgeDB . query_required_single! ( conn , &quot;insert User { name := &lt;str&gt;$username }&quot; , username : &quot;user1&quot; ) ...(2)&gt; end ) Transactions can be rollbacked using the EdgeDB.rollback/2 function or automatically if an error has occurred inside a transaction block: iex(3)&gt; { :error , :rollback } = ...(3)&gt; EdgeDB . transaction ( client , fn conn -&gt; ...(3)&gt; % EdgeDB.Object { } = EdgeDB . query_required_single! ( conn , &quot;insert User { name := &lt;str&gt;$username }&quot; , username : &quot;wrong_username&quot; ) ...(3)&gt; EdgeDB . rollback ( conn ) ...(3)&gt; end ) iex(4)&gt; EdgeDB . query_single! ( client , &quot;select User { name } filter .name = &lt;str&gt;$username&quot; , username : &quot;wrong_username&quot; ) nil Transactions are retriable. This means that if certain types of errors occur when querying data from the database, the transaction block can be automatically retried. The following types of errors can be retried retried: TransactionConflictError and its inheritors. Network errors (e.g. a socket was closed). As an example, let's create a transaction conflict to show how this works. In the first example, we will disable retries: iex(5)&gt; callback = fn conn , body -&gt; ...(5)&gt; Process . sleep ( 500 ) ...(5)&gt; EdgeDB . query! ( conn , &quot;update Post filter .author.id = &lt;uuid&gt;$user_id set { body := &lt;str&gt;$new_body }&quot; , user_id : user . id , new_body : body ) ...(5)&gt; Process . sleep ( 500 ) ...(5)&gt; end iex(6)&gt; spawn ( fn -&gt; ...(6)&gt; { :ok , client } = EdgeDB . start_link ( ) ...(6)&gt; EdgeDB . transaction ( client , &amp; callback . ( &amp;1 , &quot;new_body_1&quot; ) ) ...(6)&gt; end ) iex(7)&gt; EdgeDB . transaction ( client , &amp; callback . ( &amp;1 , &quot;new_body_2&quot; ) , retry : [ transaction_conflict : [ attempts : 0 ] ] ) ** (EdgeDB.Error) TransactionSerializationError: could not serialize access due to concurrent update Now let's execute the same thing but with enabled retries: iex(8)&gt; spawn ( fn -&gt; ...(8)&gt; { :ok , client } = EdgeDB . start_link ( ) ...(8)&gt; EdgeDB . transaction ( client , &amp; callback . ( &amp;1 , &quot;new_body_1&quot; ) ) ...(8)&gt; end ) iex(9)&gt; EdgeDB . transaction ( client , &amp; callback . ( &amp;1 , &quot;new_body_2&quot; ) ) { :ok , :ok } All failed transactions will be retried until they succeed or until the number of retries exceeds the limit (the default is 3).","ref":"usage.html#transactions","title":"Usage - Transactions","type":"extras"},{"doc":"You can also check out an example application using this client to see how to work with it: https://github.com/nsidnev/edgebeats","ref":"usage.html#example","title":"Usage - Example","type":"extras"},{"doc":"EdgeDB client for Elixir automatically converts EdgeDB types to the corresponding Elixir types and vice versa. The table below shows the correspondence between EdgeDB and Elixir types. EdgeDB Elixir Example str String.t/0 &quot;Hello EdgeDB!&quot; bool boolean/0 true , false int16 , int32 , int64 integer/0 16 float32 , float64 float/0 3.1415 bigint , decimal Decimal.t/0 #Decimal&lt;1.23&gt; json any/0 42 uuid String.t/0 &quot;0eba1636-846e-11ec-845e-276b0105b857&quot; anyenum String.t/0 &quot;green&quot; datetime DateTime.t/0 ~U[2018-05-07 15:01:22Z] duration integer/0 or Timex.Duration -420000000 , #&lt;Duration(PT7M)&gt; cal::local_datetime NaiveDateTime.t/0 ~N[2018-05-07 15:01:22] cal::local_date Date.t/0 ~D[2018-05-07] cal::local_time Time.t/0 ~T[15:01:22] cal::relative_duration EdgeDB.RelativeDuration.t/0 #EdgeDB.RelativeDuration&lt;&quot;PT45.6S&quot;&gt; cal::date_duration EdgeDB.DateDuration.t/0 #EdgeDB.DateDuration&lt;&quot;P4Y12D&quot;&gt; bytes binary/0 &lt;&lt;1, 2, 3&gt;&gt; , &quot;some bytes&quot; array&lt;anytype&gt; list/0 [1, 2, 3] anytuple tuple/0 or EdgeDB.NamedTuple.t/0 {1, 2, 3} , #EdgeDB.NamedTuple&lt;a: 1, b: 2, c: 3&gt;} object EdgeDB.Object.t/0 #EdgeDB.Object&lt;name := &quot;username&quot;&gt;} set EdgeDB.Set.t/0 #EdgeDB.Set&lt;{1, 2, 3}&gt;} cfg::memory EdgeDB.ConfigMemory.t/0 #EdgeDB.ConfigMemory&lt;&quot;5KiB&quot;&gt; range EdgeDB.Range.t/0 #EdgeDB.Range&lt;[1.1, 3.3)&gt; ext::pgvector::vector list/0 [1.5, 2.0, 4.5]","ref":"datatypes.html","title":"Datatypes","type":"extras"},{"doc":"EdgeDB.Protocol.Codec is a codec that knows how to encode or decode Elixir types into EdgeDB types and vice versa using the EdgeDB binary format. Custom codecs can be useful when your EdgeDB scalars need their own processing. NOTE Although most of the client API is complete, some internal parts may be changed in the future. The implementation of the binary protocol (including the definition of custom codecs) is on the list of possible changes. In most cases you can use already defined codecs to work with the EdgeDB binary protocol. Otherwise, you will need to check to the EdgeDB binary protocol documentation . To implement custom codec it will be required to implement EdgeDB.Protocol.CustomCodec behaviour and implement EdgeDB.Protocol.Codec protocol. As an example, let's create a custom codec for a scalar that extends the standard std::json type. module default { scalar type JSONPayload extending json; type User { required property name -&gt; str { constraint exclusive; }; required property payload -&gt; JSONPayload; } }; We will convert the following structure to default::JSONPayload : defmodule MyApp.Users.Payload do defstruct [ :public_id , :first_name , :last_name ] @type t ( ) :: % __MODULE__ { public_id : integer ( ) , first_name : String . t ( ) , last_name : String . t ( ) } end The implementation of the codec itself: defmodule MyApp.EdgeDB.Codecs.JSONPayload do @behviour EdgeDB.Protocol.CustomCodec defstruct [ ] @impl EdgeDB.Protocol.CustomCodec def new do % __MODULE__ { } end @impl EdgeDB.Protocol.CustomCodec def name do &quot;default::JSONPayload&quot; end end defimpl EdgeDB.Protocol.Codec , for : MyApp.EdgeDB.Codecs.JSONPayload do alias EdgeDB.Protocol . { Codec , CodecStorage } alias MyApp.EdgeDB.Codecs.JSONPayload alias MyApp.Users.Payload @impl Codec def encode ( _codec , % Payload { } = payload , codec_storage ) do json_codec = CodecStorage . get_by_name ( codec_storage , &quot;std::json&quot; ) Codec . encode ( json_codec , Map . from_struct ( payload ) , codec_storage ) end @impl Codec def encode ( _codec , value , codec_storage ) do raise EdgeDB.InterfaceError . new ( &quot;unexpected value to encode as \#{ inspect ( JSONPayload . name ( ) ) } : \#{ inspect ( value ) } &quot; ) end @impl Codec def decode ( _codec , data , codec_storage ) do json_codec = CodecStorage . get_by_name ( codec_storage , &quot;std::json&quot; ) payload = Codec . decode ( json_codec , data , codec_storage ) % Payload { public_id : payload [ &quot;public_id&quot; ] first_name : payload [ &quot;first_name&quot; ] last_name : payload [ &quot;last_name&quot; ] } end end Now let's test this codec: iex(1)&gt; { :ok , client } = EdgeDB . start_link ( codecs : [ MyApp.EdgeDB.Codecs.JSONPayload ] ) iex(1)&gt; payload = % MyApp.Users.Payload { public_id : 1 , first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; } iex(2)&gt; EdgeDB . query! ( client , &quot;insert User { name := &lt;str&gt;$username, payload := &lt;JSONPayload&gt;$payload }&quot; , username : &quot;user&quot; , payload : payload ) iex ( 3 ) EdgeDB.Object { } = EdgeDB . query_required_single! ( client , &quot;select User {name, payload} filter .name = &#39;user&#39; limit 1&quot; ) # EdgeDB.Object &lt; name := &quot;user&quot; , payload := % MyApp.Users.Payload { first_name : &quot;Harry&quot; , last_name : &quot;Potter&quot; , public_id : 1 } &gt;","ref":"custom-codecs.html","title":"Custom codecs for EdgeDB scalars","type":"extras"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Compare with 0.6.0","ref":"changelog.html#unreleased","title":"Changelog - Unreleased","type":"extras"},{"doc":"Compare with 0.5.1 Added support for cal::date_duration EdgeDB type via EdgeDB.DateDuration structure. support for EdgeDB Cloud. support for tuples and named tuples as query arguments. support for EdgeDB 3.0 . support for ext::pgvector::vector type. Changed implementation of Enumerable protocol for EdgeDB.Set . EdgeDB.State to EdgeDB.Client.State , EdgeDB.with_state/2 to EdgeDB.with_client_state/2 , :state option to :client_state . license from MIT to Apache 2.0 . Fixed crash after updating db_connection to 2.5 . decoding a single propery for EdgeDB.Object that equals to an empty set. not catching an EdgeDB.Error exception during parameters encoding, which caused throwing an exception for non- ! functions. silent error for calling EdgeDB API with wrong module names. Removed EdgeDB.subtransaction/2 , EdgeDB.subtransaction!/2 functions and other mentions of subtransactions support in the client. support for custom pool configuration. :raw option from EdgeDB.query* functions as well as access to EdgeDB.Query and EdgeDB.Result . API for constructing an EdgeDB.Error .","ref":"changelog.html#0-6-0-2023-06-22","title":"Changelog - [0.6.0] - 2023-06-22","type":"extras"},{"doc":"Compare with 0.5.0 Removed unintentional ping log for the connection.","ref":"changelog.html#0-5-1-2022-08-25","title":"Changelog - [0.5.1] - 2022-08-25","type":"extras"},{"doc":"Compare with 0.4.0 Added EdgeDB.Client module that is acceptable by all EdgeDB API. :max_concurrency option to start pool to control max connections count in EdgeDB.Pool . Changed default pool from DBConnection.Pool to EdgeDB.Pool . EdgeDB.Pool to be &quot;real&quot; lazy and dynamic: all idle connections that EdgeDB wants to drop will be disconnected from the pool, new connections will be created only on user queries depending on EdgeDB concurrency suggest as soft limit and :max_concurrency option as hard limit of connections count. first parameter accepted by callbacks in EdgeDB.transaction/3 , EdgeDB.subtransaction/2 and EdgeDB.subtransaction!/2 from DBConnection.t/0 to EdgeDB.Client.t/0 . EdgeDB.connection/0 to EdgeDB.client/0 . EdgeDB.edgedb_transaction_option/0 to EdgeDB.Client.transaction_option/0 . EdgeDB.retry_option/0 to EdgeDB.Client.retry_option/0 . EdgeDB.retry_rule/0 to EdgeDB.Client.retry_rule/0 . Fixed concurrent transactions when client was unintentionally marked as borrowed for transaction instead of connection. Removed EdgeDB.WrappedConnection module in favor of EdgeDB.Client .","ref":"changelog.html#0-5-0-2022-08-20","title":"Changelog - [0.5.0] - 2022-08-20","type":"extras"},{"doc":"Compare with 0.3.0 Added support for EdgeDB 2.0 with new binary protocol. support for EdgeQL state via EdgeDB.State . new EdgeDB.Range type to represent ranges from EdgeDB 2.0 . support for multiple EdgeQL statements execution via EdgeDB.execute/4 and EdgeDB.execute!/4 . Changed io_format option to output_format . Fixed the ability to pass maps or keyword lists in a query that requires positional arguments.","ref":"changelog.html#0-4-0-2022-08-04","title":"Changelog - [0.4.0] - 2022-08-04","type":"extras"},{"doc":"Compare with 0.2.1 Added maps as a valid type for query arguments. EdgeDB.Object.to_map/1 and EdgeDB.NamedTuple.to_map/1 functions. optional support for std::datetime EdgeDB type via Timex.Duration structure. custom modules for each EdgeDB exception with the new/2 function, that will return the EdgeDB.Error exception. documentation for EdgeDB.Error functions that create new exceptions. Removed legacy arguments encoding. Changed EdgeQL queries to be lowercase. EdgeDB.Error.inheritor?/2 to work with generated module names for EdgeDB exceptions instead of atoms.","ref":"changelog.html#0-3-0-2022-05-29","title":"Changelog - [0.3.0] - 2022-05-29","type":"extras"},{"doc":"Compare with 0.2.0 Removed mention of :repeatable_read option for transaction isolation mode from t:EdgeDB.edgedb_transaction_option/0 . Fixed codec name returned by codec for std::str from std::uuid to str::str . documentation for the custom codec example, which did not have a EdgeDB.Protocol.Codec.decode/3 implementation and used the wrong protocol.","ref":"changelog.html#0-2-1-2022-05-19","title":"Changelog - [0.2.1] - 2022-05-19","type":"extras"},{"doc":"Compare with 0.1.0 Added EdgeDB.Object.fields/2 , EdgeDB.Object.properties/2 , EdgeDB.Object.links/1 and EdgeDB.Object.link_properties/1 functions to inspect the fields of the object. EdgeDB.Error.inheritor?/2 function to check if the exception is an inheritor of another EdgeDB error. EdgeDB.Sandbox module for use in tests involving database modifications. EdgeDB.Pool to support dynamic resizing of the connection pool via messages from EdgeDB server. Fixed creation of EdgeDB.Object properties equal to an empty EdgeDB.Set . access to TLS certificate from connection options. isolation configuration by dropping REPEATABLE READ mode, because only SERIALIZABLE is supported by EdgeDB 1.0 ( REPEATABLE READ was dropped in EdgeDB 1.3 ). preserving the order of the values returned when working with EdgeDB.NamedTuple ( EdgeDB.NamedTuple.to_tuple/1 , EdgeDB.NamedTuple.keys/1 ), including Enumerable protocol implementation. Changed parsing of binary data from EdgeDB by completely reworking the protocol implementation. internal implementation of the Access behaviour for EdgeDB.Object to improve fields access performance.","ref":"changelog.html#0-2-0-2022-05-03","title":"Changelog - [0.2.0] - 2022-05-03","type":"extras"},{"doc":"Compare with first commit Added First release.","ref":"changelog.html#0-1-0-2022-02-10","title":"Changelog - [0.1.0] - 2022-02-10","type":"extras"}]